#!/bin/sh
# <BEGIN COPYRIGHT>
# This file is part of the "Bad Penguin" GNU/Linux distribution
# Copyright (C) 1997-98-99 by Antonio GALLO
# Home Page at ......: http://www.badpenguin.org
# Home Page at ......: http://www.linux.it/~agx/
# e-mail contact ....: mailto:agx@linux.it	mailto:agx@geocities.com
# This program is distributed under the GNU General Public License
# You are not allowed to remove the copyright notice
# <END COPYRIGHT>

# 1.0.0 by agx@linux.it 
# This is version 1.100 of this script
# 1999-11-29, Version 1.2.0 by AGX

MSG_01="Modules/driver loading"
MSG_02="Choose the source from where you want to load additional modules"
MSG_03="Select the SOURCE directory, first !"
MSG_04="Select a module folder then press ENTER"
MSG_05="Reading Modules ..."
MSG_06="Select a module then ENTER to load it"
MSG_10="Modules loading from floppy completed. Press ENTER to continue ..."
MSG_20="distribution source"
if [ "$LANG" = "it_IT" ]; then
  MSG_01="Selezione moduli da caricare"
  MSG_02="Scegli da dove caricare i devices"
  MSG_03="Devi selezionare prima SOURCE !"
  MSG_04="Seleziona una cartella con i moduli poi premi INVIO"
  MSG_05="Lettura elenco moduli in corso ..."
  MSG_06="Seleziona un modulo poi premi ENTER per caricarlo"
  MSG_10="Lettura dei moduli da dischetto completata. Premere INVIO per continuare ..."
  MSG_20="dalla distribuzione"
fi


TEMPDIR="$HOME/tmp"
[ ! -d $TEMPDIR ] && mkdir -p $TEMPDIR
TEMPSCRIPT="$TEMPDIR/emod-tempscript.$$"
TEMPDATA="$TEMPDIR/emod-tempdata.$$"
TEMPMODULE="$TEMPDIR/emod-tempmod.$$"
trap 'rm -f $TEMPSCRIPT $TEMPDATA $TEMPMODULE ; exit $USCITA ' 0
USCITA=0



rm -f $TEMPDATA
mdir="/lib/modules/`uname -r`/"
if [ ! -d $mdir ]
then
	dialog --msgbox "\nWARNING: no modules present for this kernel" 7 59
	exit 0
fi


# Build Main Directories
cd /usr/local/lib/agx-modulemanager/
while [ 0 ]; do
    > $TEMPSCRIPT
    for i in $mdir/*; do
	if [ -d $i ]; then
	    NOME="`basename $i`"
	    DESC=""
	    case $NOME in
		block)
		    DESC="disk and block devices"
		;;
		cdrom)
		    DESC="old non IDE CD-ROM modules"
		;;
		fs)
		    DESC="additional FileSystems modules"
		;;
		ipv4)
		    DESC="Internet Protocol drivers"
		;;
		misc)
		    DESC="misc device like mouse and others"
		;;
		net)
		    DESC="Network Card and Protocols"		
		;;
		pcmcia)
		    DESC="PCMCIA cards"		
		;;
		scsi)
		    DESC="SCSI controllers and devices"
		;;
		video)
		    DESC="video 4 linux device modules"
		;;
		*)
		    DESC="$NOME modules"
		    ;;
	    esac
	    #	    
	    echo -n "$NOME:$DESC:" >> $TEMPSCRIPT
	fi
    done
    
    IFS=":"

MSG_04="Modules are loadable device drivers. You should not install modules\n\
for devices that aren't installed in your system, as they will\n\
sometimes cause the system to pause for a long time while it \n\
is searching for the device. Also, drivers for devices that\n\
you don't have use memory that you could put to better use.\n\
\nPlease select the category of modules."


    dialog --title "Module Configuration"  --menu "$MSG_04" 21 75 8 `cat $TEMPSCRIPT` 2> $TEMPDATA
    if [ $? -ne 0 ]; then
	exit 1
    fi
    DIRNAME="`cat $TEMPDATA`"
	
    # Read Modules
    dialog --infobox " \n $MSG_05" 5 38
    > $TEMPSCRIPT
    for i in $mdir/$DIRNAME/*; do
	if [ -f $i ]; then 
	    NOME="`basename $i .o`"
	    DESC="(no description)"
	    if [ -f /etc/sysconfig/$PROFILE/$NOME.module ]; then
		INSTALLED="[X] "
	    else
		INSTALLED="    "
	    fi
	    while read tmp_name tmp_descr ; do
		if [ "$tmp_name" = "$NOME" ]; then
		    DESC="$tmp_descr"
		    break;
		fi
	    done < modules.db
	    echo -n "$NOME:$INSTALLED$DESC:" >> $TEMPSCRIPT
	fi
    done
    #
    IFS=":"
    dialog --menu "$MSG_06" 24 79 17 `cat $TEMPSCRIPT` 2> $TEMPDATA
    if [ $? -ne 0 ]; then
	continue
    fi
    MODNAME="`cat $TEMPDATA`"
    MODFILE="$mdir/$DIRNAME/$MODNAME.o"
    clear
    echo -e " \n $MSG_05 $MODNAME -> $MODFILE ...."
    #
    TROVATO=0
    CONTA=0
    > $TEMPSCRIPT

    while read linea; do
      if [ "$linea" = "@$MODNAME" ]; then
        TROVATO=1
      elif [ $TROVATO -eq 1 ]; then
        case "$linea" in 
	  \$*)
	    break
	    ;;
	  @*)
	    break
	    ;;
	  *)
	    echo "$linea" >> $TEMPSCRIPT
	    CONTA=$[ CONTA + 1 ]
	    ;;
	esac
      fi
    done < modules.descr


    # Controllo presenza modulo
    if [ -f /etc/sysconfig/$PROFILE/$MODNAME.module ]; then
        MSG_80="Un modulo con lo stesso nome e' gia presente nel sistema"
	dialog --title "Attivazione modulo" --menu "$MSG_80" 10 70 3 \
		"1" "Imposta ed attiva questo modulo" \
		"2" "Disattiva l'utilizzo di questo modulo" 2> $TEMPDATA
	REPLY=$?
	if [ $REPLY -ne 0 ]; then
	    continue
	fi
	CHOICE="`cat $TEMPDATA`"
	if [ "$CHOICE" = "2" ]; then
	    rm -f /etc/sysconfig/$PROFILE/$MODNAME.module
	    REPLY=$?
	    rmmod $MODNAME
	    if [ $REPLY -eq 0 ]; then
		dialog --msgbox "Il modulo e' stato rimosso dal sistema" 5 50
	    else
		dialog --msgbox "Problemi nel rimuovere il modulo dal sistema" 5 50
	    fi
	    continue
	fi
    fi


    # --- Caricamento Modulo ---
    MSG_80="Hai deciso di caricare il modulo: $MODNAME\n"
    MSG_81="Vengono di seguito riportati i possibili parametri\n"
    MSG_82="Digita i parametri che preferisci e premi OK per\n"
    MSG_83="caricare il modulo oppure CANCEL per annullare."
    
    dialog --title "Caricamento modulo" \
	--inputbox "$MSG_80$MSG_81$MSG_82$MSG_83\n\n`head -n 12 $TEMPSCRIPT`\n" \
	24 75 2> $TEMPMODULE
    if [ $? -ne 0 ]; then
	continue
    fi
    #
    clear
# ---------------------------------------
    echoc GREEN "Preparazione script..."
# ---------------------------------------
cat > /etc/sysconfig/$PROFILE/$MODNAME.module << EOF
#!/bin/sh
lsmod | grep -q $MODNAME >/dev/null
if [ \$? -eq 0 ]; then
  echo "Module $MODNAME is already loaded, skipping."
  exit 0
fi
echo "Probing module $MODNAME with parameters"
modprobe $MODNAME `cat $TEMPMODULE 2>/dev/null`
if [ \$? -ne 0 ]; then
    echo "Inserting module $MODNAME with parameters"
    insmod $MODFILE `cat $TEMPMODULE 2>/dev/null`
    if [ \$? -ne 0 ]; then
	modprobe $MODNAME
	if [ \$? -ne 0 ]; then
	    insmod $MODFILE
	    exit \$?
	fi
    fi
fi
EOF
# --------------------------------------------
    lsmod | grep -q $MODNAME >/dev/null
    if [ $? -eq 0 ]; then
      echoc GREEN "Rimozione modulo precedente"
      rmmod $MODNAME
      sleep 2
    fi
    #
    echoc GREEN "Caricamento modulo ..."
    sh /etc/sysconfig/$PROFILE/$MODNAME.module
    REPLY=$?
    if [ $REPLY -eq 0 ]; then
        echoc GREEN "Modulo caricato con successo."
    else
	echoc RED "Spiacente, errore nr. $REPLY"
    fi
    echo
    echo "Press ENTER to continue."
    read x
done
